import processing.core.*; 

import processing.serial.*; 
import ddf.minim.*; 
import ddf.minim.signals.*; 
import ddf.minim.analysis.*; 
import ddf.minim.effects.*; 
import controlP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class HoratioConfigUtil extends PApplet {











   Serial myPort;

Minim minim;
AudioPlayer start, ringloop, end;

ControlP5 controlP5;

public int On1_value;
public int Off1_value;
public int On2_value;
public int Off2_value;
public int Freq_value;

public boolean go = false;

Textfield On1_text, On2_text, Off1_text, Off2_text;
Textfield Freq_text;
Toggle Freq_override;

Toggle Disable_LED;
Toggle MIDI_Enable;
Toggle MIDI_Disable_Button;
Toggle DMX_Enable;
Toggle DMX_Disable_Button;
Textfield MIDI_device;
Textfield MIDI_note;
Textfield DMX_address;
Textfield DMX_threshold;

Button download;

Button test;

ListBox l;
ListBox listports;

int serialPort;

CountryCode[] codes;
String[] temp;

public void setup() {
  size(340,400);
  frameRate(25);
  String[] codeload = loadStrings("countrycodes.txt");
  codes = new CountryCode[codeload.length];  

  for(int x = 0; x < codeload.length; x++)
  {
      temp = split(codeload[x],',');
       codes[x] = new CountryCode();
       codes[x].Name = temp[0];
       codes[x].Freq = PApplet.parseInt(temp[1]);
       codes[x].On1 = PApplet.parseInt(temp[2]);
       codes[x].Off1 = PApplet.parseInt(temp[3]);
       codes[x].On2 = PApplet.parseInt(temp[4]);
       codes[x].Off2 = PApplet.parseInt(temp[5]);
  }
  
  minim = new Minim(this);
  start = minim.loadFile("ring_start.wav");
  ringloop = minim.loadFile("ring_loop.wav");
  end = minim.loadFile("ring_decay.wav");

  controlP5 = new ControlP5(this);
  
  listports = controlP5.addListBox("ports",180,20,140,75);
  listports.captionLabel().set("Serial Ports");
  
  for(int x = 0; x < Serial.list().length; x++)
  {
      listports.addItem(Serial.list()[x],x);
    
  }  
  
  
  On1_text = controlP5.addTextfield("On1",20,100,60,20);
  On1_text.setAutoClear(false);
  On1_text.setValue("2000");
  Off1_text = controlP5.addTextfield("Off1",100,100,60,20);
    Off1_text.setAutoClear(false);
  Off1_text.setValue("4000");

  On2_text = controlP5.addTextfield("On2",180,100,60,20);
    On2_text.setAutoClear(false);
  On2_text.setValue("2000");

  Off2_text = controlP5.addTextfield("Off2",260,100,60,20);
    Off2_text.setAutoClear(false);
  Off2_text.setValue("4000");

  Freq_text = controlP5.addTextfield("Frequency",20,150,60,20);
    Freq_text.setAutoClear(false);
  Freq_text.setValue("20");

  Freq_override = controlP5.addToggle("FreqOver",true,100,150,20,20);
  Freq_override.captionLabel().set("Override Freq");
  Disable_LED = controlP5.addToggle("DisableLED",false,180,150,20,20);
  Disable_LED.captionLabel().set("Disable LED");
  
  test = controlP5.addButton("TestRing",0,260,150,60,20);
  test.captionLabel().set("Test Ringer");
  
  l = controlP5.addListBox("countries",20,20,140,75);
  l.setItemHeight(15);
  l.setBarHeight(15); 
  l.captionLabel().set("Preset Ringtones");
  addCountries();
  
  /*
  Toggle MIDI_Enable;
Toggle MIDI_Disable_Button;
Toggle DMX_Enable;
Toggle DMX_Disable_Button;
Textfield MIDI_device;
Textfield MIDI_note;
Textfield DMX_address;
Textfield DMX_threshold;
*/

  MIDI_Enable = controlP5.addToggle("MIDIE",false,20,200,20,20);
  MIDI_Enable.captionLabel().set("Enable MIDI");
  
  MIDI_Disable_Button = controlP5.addToggle("MIDIDB",false,140,200,20,20);
  MIDI_Disable_Button.captionLabel().set("Disable Button");
  
  MIDI_device = controlP5.addTextfield("MIDID",20,240,60,20);
  MIDI_device.captionLabel().set("MIDI Channel");
  MIDI_device.setValue("1");
  
  MIDI_note = controlP5.addTextfield("MIDIN",20,280,60,20);
  MIDI_note.captionLabel().set("MIDI Note");
  MIDI_note.setValue("60");
 
  DMX_Enable = controlP5.addToggle("DMXE",false,260,200,20,20);
  DMX_Enable.captionLabel().set("Enable DMX");
  
  DMX_address = controlP5.addTextfield("DMXA",260,240,60,20);
  DMX_address.captionLabel().set("DMX Address");
  DMX_address.setValue("500");
  
  DMX_threshold = controlP5.addTextfield("DMXT",260,280,60,20);
  DMX_threshold.captionLabel().set("DMX Threshold");
  DMX_threshold.setValue("127");  
  
  download = controlP5.addButton("Update",0,140,320,60,20);
   
}

public void MIDIE(int value)
{
   if(value == 1)
   {  
     DMX_Enable.setState(false);  
   }
   
}

public void DMXE(int value)
{
  if(value == 1)
{
  MIDI_Enable.setState(false); 
}
}

public void draw() {
  background(127);
  if(go == true)
  {
     //start.play(); 
     //delay(start.length());
     //start.pause();
     ringloop.loop();
     delay(PApplet.parseInt(On1_text.getText()));
     end.play();
     ringloop.pause();
     delay(PApplet.parseInt(Off1_text.getText()));
     end.pause();
     end.rewind();
     ringloop.loop();
     delay(PApplet.parseInt(On2_text.getText()));
     end.play();
     ringloop.pause();
     delay(PApplet.parseInt(Off2_text.getText()));
     end.pause();
     end.rewind();
     go = false;    
  }
  
}

public void addCountries()
{
 
  for(int x = 0; x < codes.length; x++)
  {
      l.addItem(codes[x].Name,x);
  }
  
  
}

public void controlEvent(ControlEvent theEvent) {
  // ListBox is if type ControlGroup.
  // 1 controlEvent will be executed, where the event
  // originates from a ControlGroup. therefore
  // you need to check the Event with
  // if (theEvent.isGroup())
  // to avoid an error message from controlP5.

  if (theEvent.isGroup()) {
    // an event from a group e.g. scrollList
    //println(theEvent.group().value()+" from "+theEvent.group());
    int ActiveCode = PApplet.parseInt(theEvent.group().value());
    println(PApplet.parseInt(theEvent.group().value()));
    println(theEvent.group().name());
    if(theEvent.group().name() == "countries")
    {
    On1_text.setValue(Integer.toString(codes[ActiveCode].On1));
    On2_text.setValue(Integer.toString(codes[ActiveCode].On2));
    Off1_text.setValue(Integer.toString(codes[ActiveCode].Off1));
    Off2_text.setValue(Integer.toString(codes[ActiveCode].Off2));
    Freq_text.setValue(Integer.toString(codes[ActiveCode].Freq));
    Freq_value = codes[ActiveCode].Freq;
    }
    if(theEvent.group().name() == "ports")
    {
    serialPort = ActiveCode;
    }
    
  }
  else
  {     }
}

public void Update(int value)
{
   int timer;
   byte data;
   int temp_data;
   
   println(serialPort);

   myPort = new Serial(this, Serial.list()[serialPort], 9600); 
   timer = millis() + 10000;
   myPort.write('x');
   while(timer > millis() && myPort.available() == 0);
   println(millis() - (timer - 10000));
   while(myPort.available() > 0)
   {
     println(myPort.read());
   }
       
   myPort.clear();
   myPort.write("xxx");
   timer = millis() + 10000;
   while(timer > millis() && myPort.available() == 0);
   println(millis() - (timer - 10000));
   if(myPort.read() == 'x')
   {
       myPort.write(0x55); // 0x55 for start code 
       temp_data =  PApplet.parseInt(On1_text.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte on1;
       data = PApplet.parseByte((temp_data >>> 8)); 
       myPort.write(data); // Hih byte on1;
       
       temp_data =  PApplet.parseInt(Off1_text.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte off1;
       data = PApplet.parseByte(temp_data >>> 8); 
       myPort.write(data); // Hih byte off1;
       
       temp_data =  PApplet.parseInt(On2_text.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte on2;
       data = PApplet.parseByte(temp_data >>> 8); 
       myPort.write(data); // Hih byte on2;
       
       temp_data =  PApplet.parseInt(Off2_text.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte off2;
       data = PApplet.parseByte(temp_data >>> 8); 
       myPort.write(data); // Hih byte off2;
       
       if(Freq_override.getState() == false)
       {
       temp_data =  PApplet.parseInt(Freq_text.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte Freq;
       }
       else
       {
       myPort.write(20);    // 20Hz override
       }

      if(Disable_LED.getState() == false)
      {
        myPort.write(0);
      }
      else
      {
        myPort.write(1);
      }
      
      if(MIDI_Disable_Button.getState() == false)
      {
          myPort.write(0);
      }
      else
      {
         myPort.write(1);
      }
      
      if(MIDI_Enable.getState() == true)
      {
          myPort.write(1);
      }
      else if(DMX_Enable.getState() == true)
      {
          myPort.write(2);
      }
      else
      { 
          myPort.write(0);
      }
      
       temp_data =  PApplet.parseInt(MIDI_device.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte MIDI Dev;
      
       temp_data =  PApplet.parseInt(MIDI_note.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte MIDI Note;
       
       temp_data =  PApplet.parseInt(DMX_address.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte DMX Addr;
       data = PApplet.parseByte(temp_data >>> 8); 
       myPort.write(data); // Hih byte DMX Addr;
       
       temp_data =  PApplet.parseInt(DMX_threshold.getText());
       data = PApplet.parseByte(temp_data);
       myPort.write(data); // Low byte DMX Threshold;
       
       myPort.write(0x55);
       myPort.write(0x55);
  
   }
   
   delay(1000);
   myPort.clear();
   myPort.stop();
  
}

public void TestRing(int theValue)
{
   println(theValue); 
   go = true;
}

public void stop()
{
// the AudioPlayer you got from Minim.loadFile()
start.close();
ringloop.close();
end.close();
minim.stop();

// this calls the stop method that
// you are overriding by defining your own
// it must be called so that your application
// can do all the cleanup it would normally do
super.stop();
}
class CountryCode {
  
  public String Name;
  public int Freq;
  public int On1;
  public int On2;
  public int Off1;
  public int Off2;
  
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "HoratioConfigUtil" });
  }
}
